# -*- coding: utf-8 -*-

from artixds.conditionfunctionplugins.conditionplugin import add_plugin
from artixds.generalfunction.conditionhelper import  __dayIn
from datetime import date,datetime

class WrapQTime(object):    

    def __init__(self, sourcedate):
        
        self._day = sourcedate.day 
        self._month = sourcedate.month
        self._year = sourcedate.year
        
    def day(self):
        return self._day

    def month(self):
        return self._month

    def year(self):
        return self._year
        

@add_plugin
def celebrationDay(self, dateStr, firstDay = None, lastDay = None, dateFormat = '%d.%m.%Y'):
    if dateStr != None:
        currentDate = self.check["datetimebeg"].date()    
        try:
            testDate = WrapQTime(datetime.strptime(dateStr, dateFormat))
        except ValueError:
            pass
        else:
            return __dayIn(currentDate, testDate, firstDay, lastDay)
    
    return False
