# -*- coding: utf-8 -*-
'''
Created on 14 окт. 2013 г.

@author: kov
'''

def getImpact(self, number, percent, desc):
    '''
    Функция разварачивает чек на позиции.
    Возвращает словарь из номеров позиций в качестве ключей
    и суммы скидки в качестве значений

    number - каждый следующий номер позиции
    percent - процент скидки
    desc - сортировать по убыванию цены
    '''
    # Отсортированный развернутый список номеров позиций чека posNum по сумме позиции
    extCheck = []

    for item in self.check['goodsitems']:

        # Для корректного прохождения тестов необходим ключ 'tmcunit'
        if 'tmcUnit' in item:
            item['tmcunit'] = item['tmcUnit']

        # Если товар не весовой, разбиваем его на позиции
        quantItem = 1 if item['tmcunit']['fractional'] else int(item['bquant'])
        for pos in range(quantItem):
            extCheck.append((item['posnum'], item['price'] * percent / 100.0))

    extCheck = sorted(extCheck, key=lambda k: k[1])
    if desc:
        extCheck.reverse()

    # Список n-х позиций
    positions = []
    for it in range(number - 1, len(extCheck), number):
        positions.append(extCheck[it])
    result = {}
    for posn in positions:
        if not posn[0] in result:
            result[posn[0]] = 0
        result[posn[0]] = result[posn[0]] + posn[1]

    return result
