# -*- coding: utf-8 -*-

def discountCount(self, id, multiplyByQuantity=False):
    '''
    Функция подсчитывает количество воздействий скидки с указанным id
    id - id скидки
    multiplyByQuantity - Считать каждое воздействие не за одно, а за <количество в позиции>. Имеет смысл, если настроено объединение позиций в кассе или, например, в наборах
    Возвращает количество воздействий
    '''
    count = 0
    for impact in self.checkWrapper.check.getDiscountList():
        for positionData in impact.details.values():
            if positionData.get("discountcode", 0) == id:
                if multiplyByQuantity:
                    for position in self.checkWrapper.check.getGoodsList():
                        if position.posnum == positionData.get("position", 0):
                            count += position.bquant
                            break
                else:
                    count += 1
    return count
