'''
Created on 15.03.2011

@author: gsu
'''

import logging
from ast import parse, dump
from inspect  import getsource

ratefunctionclass = None
rateMemory = {}

def memoized(func):
    def memo(self, *args,**kwargs):
        if func.__name__ in ratefunctionclass.posConditionList:
            return func(self, *args, **kwargs)
        key = '%s.%s.%s' % (self.checkWrapper.id, func.__name__, args)
        if not key in rateMemory:
            rateMemory[key] = func(self, *args, **kwargs)
        return rateMemory[key]
    return memo

def add_plugin(func):
    if "'object'" in str(dump(parse( getsource(func)))):
        if not hasattr(ratefunctionclass, "posConditionList"):
            setattr(ratefunctionclass, "posConditionList", ['object'])
        getattr(ratefunctionclass, "posConditionList").append(func.__name__)
    setattr(ratefunctionclass, func.__name__, memoized(func))
