from artixds.ratefunctionplugins.rateplugin import add_plugin
from artixds.ratefunctionplugins.extendedoption import ExtendedOption, ExtendedOptions

@add_plugin
def getValueByOptionPreffix(self, preffix, values, defaultValue = 0.0):
    eopt = ExtendedOptions(self.object.data["extendetoptions"])
    key = next((opt.option for opt in eopt.options if opt.like(preffix)), None)
    return values[key] if key in values.keys() else defaultValue
