# -*- coding: utf-8 -*-
'''
Created on 26.08.2010

@author: gsu
'''

import sys
if __name__ == "__main__":
    sys.path.append('..')

from roster import Roster, RosterItem
from artixds.objectdiscount import Kit, KitItem
from artixds.discountrate import KitDiscountRate, KitDiscountRateItem, SumDiscountRate

def test():
    roster = Roster(items=[RosterItem(positionNumber=1, code='1', quantity=3.0, sumn = 77.0),
                           RosterItem(positionNumber=1, code='4', quantity=1.0, sumn = 12.0),
                           RosterItem(positionNumber=2, code='33', quantity=5.0, sumn = 32.0),
                           RosterItem(positionNumber=3, code='12', quantity=2.0, sumn = 14.0)])
    kit = Kit(items=[KitItem(codes=['4', '1', '32'], quantity=2), KitItem(codes=['33', '7', '12'], quantity=3)])

    roster = Roster(items=[RosterItem(positionNumber=1, code='1', quantity=10, sumn = 77.0)])
    kit = Kit(items=[KitItem(codes=['1'], quantity=2), KitItem(codes=['1'], quantity=3)])

    kdr=KitDiscountRate(items=[KitDiscountRateItem(kitItem=kit.items[1], discountRate=SumDiscountRate(7))])
    print roster
    print kit
    entry = roster.findKit(kit)
    while entry:
        roster.subtractKitEntry(entry)
        entry = roster.findKit(kit)
    print entry
    for item in roster:
        print item
    print roster
    roster.applyRate(kdr)
    for item in roster:
        print item
    print roster.structureImpacts()
    print roster.pureImpacts()

if __name__ == "__main__":
    test()
