'''
Created on 24.04.2013

@author: lsyu
'''

from artixds.conditionfunctionplugins.conditionplugin import add_plugin
from artixds.generalfunction.conditionhelper import __getAsList

def _strToMap(str):
    retMap = {}
    for line in str.split("\n"):
        if line.strip():
            val = [substr.strip() for substr in line.split("=") if substr.strip()]
            retMap[val[0]] = val[1] if len(val) > 1 else None
    return retMap

@add_plugin
def hasShopOptions(self, options):
    if not self.check or not self.check["context"] or not self.check["context"]["shopoptions"]:
        return False
    return True if set(_strToMap(self.check["context"]["shopoptions"]).keys()) & set(__getAsList(options)) else False


@add_plugin
def getShopOptionValue(self, key):
    if not self.check or not self.check["context"] or not self.check["context"]["shopoptions"]:
        return None
    mapOpt = _strToMap(self.check["context"]["shopoptions"])
    return mapOpt[str(key)] if str(key) in mapOpt else None

