# -*- coding: utf-8 -*-

from datetime import date
from dateutil.relativedelta import relativedelta

def age(self):
    '''
    Функция определяет возраст покупателя
    Возвращает количество полных лет, если указана дата рождения клиента, 0 - если дата не указана
    '''
    age = 0
    if self.card and self.card["card"] and self.card["card"]["client"]:
        birthday = self.card["card"]["client"]["birthday"]
        if birthday.isValid():
            age = relativedelta(date.today(), date(birthday.year(), birthday.month(), birthday.day())).years
    return age
