
from artixds.generalfunction.conditionhelper import __inventInCheckByCatalog, __inventInCheckWithAllCatalogs
from functools import reduce

def inventCountInCheckByCatalog(self, catalog, withPartOfKit = True):
    sel = __inventInCheckByCatalog(self.checkWrapper, catalog, withPartOfKit)
    return len(sel)      

def inventQuantInCheckByCatalog(self, catalog, withPartOfKit = True):
	sel = __inventInCheckByCatalog(self.checkWrapper, catalog, withPartOfKit)
	return reduce(lambda x,y: x + y, map(lambda x: x["cquant"],sel)) if sel else 0 

def inventSumInCheckByCatalog(self, catalog, withPartOfKit = True):
	sel = __inventInCheckByCatalog(self.checkWrapper, catalog, withPartOfKit)
	return reduce(lambda x,y: x + y, map(lambda x: x['sumb'], sel)) if sel else 0 


def inventCountInCheckWithAllCatalogs(self, catalogs, withPartOfKit = True):
    sel = __inventInCheckWithAllCatalogs(self.checkWrapper,catalogs, withPartOfKit)
    return len(sel) 

def inventQuantInCheckWithAllCatalogs(self, catalogs, withPartOfKit = True):
    sel = __inventInCheckWithAllCatalogs(self.checkWrapper,catalogs, withPartOfKit)
    return reduce(lambda x,y: x + y, map(lambda x: x["cquant"],sel)) if sel else 0 

def inventSumInCheckWithAllCatalogs(self, catalogs, withPartOfKit = True):
	sel = __inventInCheckWithAllCatalogs(self.checkWrapper,catalogs, withPartOfKit)
	return reduce(lambda x,y: x + y, map(lambda x: x['sumb'], sel)) if sel else 0 