
from artixds.generalfunction.conditionhelper import __inventInCheckByOption, __inventInCheckWithAllOptions
from functools import reduce

def inventCountInCheckByOption(self, options, withPartOfKit = True):
    sel = __inventInCheckByOption(self.checkWrapper, options, withPartOfKit)
    return len(sel)      
             
def inventQuantInCheckByOption(self, options, withPartOfKit = True):
    sel = __inventInCheckByOption(self.checkWrapper, options, withPartOfKit)
    return reduce(lambda x,y: x + y, map(lambda x: x["cquant"],sel)) if sel else 0 
	
def inventSumInCheckByOption(self, options, withPartOfKit = True):        
    sel = __inventInCheckByOption(self.checkWrapper, options, withPartOfKit)
    return reduce(lambda x,y: x + y, map(lambda x: x['sumb'], sel)) if sel else 0 


def inventCountInCheckWithAllOptions(self, options, withPartOfKit = True):
    sel = __inventInCheckWithAllOptions(self.checkWrapper, options, withPartOfKit)
    return len(sel) 

def inventQuantInCheckWithAllOptions(self, options, withPartOfKit = True):
    sel = __inventInCheckWithAllOptions(self.checkWrapper, options, withPartOfKit)
    return reduce(lambda x,y: x + y, map(lambda x: x["cquant"], sel)) if sel else 0 
	
def inventSumInCheckWithAllOptions(self, options, withPartOfKit = True):
    sel = __inventInCheckWithAllOptions(self.checkWrapper, options, withPartOfKit)
    return reduce(lambda x,y: x + y, map(lambda x: x['sumb'], sel)) if sel else 0 
	

	