# -*- coding: utf-8 -*-

def proportionalDiscount(self, sum, conditions):
    result = {}
    items = []
    discountBase = 0.0
    plugin = __import__('artixds.discountcondition', fromlist='q')
    ds = plugin.DiscountCondition(condition=conditions)
    ds.checkWrapper = self.checkWrapper

    for item in self.checkWrapper.getGoodsList():
        if self.checkWrapper.isPartOfKit(item.data['posnum']) or not ds.validate(check=self.checkWrapper.checkDict, object=item.data):
            continue
        discountBase += item.data['sumb']
        items.append(item)

    changeSum = sum
    for item in items:
        discountSumForPosition = round(item.data['sumb'] / discountBase * sum, 2) if discountBase > 0.005 else 0.0
        if changeSum - discountSumForPosition < 0.005:
            discountSumForPosition = changeSum
        result[item.data['posnum']] = discountSumForPosition
        changeSum -= discountSumForPosition

    # остаток пихаем в первый элемент
    if changeSum > 0.005 and result.keys():
        result[next(iter(result))] += changeSum

    return result
