'''
Created on 22.08.2012

@author: lrp
'''

from artixds.ratefunctionplugins.rateplugin import add_plugin
from artixds.generalfunction.conditionhelper import __dateTimeIn
from datetime import datetime
     
@add_plugin   
def getMultiplicator(self, defaultValue=1.0,useSystemDate=False): 
    
        if not self.check["datetimebeg"] or not (self.card["card"]["multiplicatorbeg"] or self.card["card"]["multiplicatorend"]):
            return self.card["card"]["multiplicator"] if self.card["card"]["multiplicator"] else defaultValue
        currentDate = datetime.strptime(self.check["datetimebeg"].toString("yyyy-MM-ddThh:mm:ss"), "%Y-%m-%dT%H:%M:%S") if not useSystemDate else datetime.now()         
        if __dateTimeIn(currentDate, 
                        datetime.strptime(self.card["card"]["multiplicatorbeg"].toString("yyyy-MM-ddThh:mm:ss"), "%Y-%m-%dT%H:%M:%S"), 
                        datetime.strptime(self.card["card"]["multiplicatorend"].toString("yyyy-MM-ddThh:mm:ss"), "%Y-%m-%dT%H:%M:%S")):                   
            return self.card["card"]["multiplicator"] if self.card["card"]["multiplicator"] else defaultValue           
        return self.card["card"]["multiplicatorcurrent"] if self.card["card"]["multiplicatorcurrent"] else defaultValue
   

